"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var hasAlias = function (aliases) { return function (imported) { return aliases.some(function (alias) { return imported.moduleName.indexOf(alias) === 0; }); }; };
exports.default = (function (styleApi, file, options) {
    var alias = styleApi.alias, and = styleApi.and, dotSegmentCount = styleApi.dotSegmentCount, hasNoMember = styleApi.hasNoMember, isNodeModule = styleApi.isNodeModule, isAbsoluteModule = styleApi.isAbsoluteModule, isRelativeModule = styleApi.isRelativeModule, moduleName = styleApi.moduleName, naturally = styleApi.naturally, not = styleApi.not, unicode = styleApi.unicode;
    var isAliasModule = hasAlias(options.alias || []);
    return [
        // import "foo"
        { match: and(hasNoMember, isAbsoluteModule, not(isAliasModule)) },
        { separator: true },
        // import "{relativeAlias}/foo"
        { match: and(hasNoMember, isAbsoluteModule, isAliasModule) },
        { separator: true },
        // import "./foo"
        { match: and(hasNoMember, isRelativeModule) },
        { separator: true },
        // import … from "fs";
        {
            match: isNodeModule,
            sort: moduleName(naturally),
            sortNamedMembers: alias(unicode)
        },
        { separator: true },
        // import … from "foo";
        {
            match: and(isAbsoluteModule, not(isAliasModule)),
            sort: moduleName(naturally),
            sortNamedMembers: alias(unicode)
        },
        { separator: true },
        // import … from "{relativeAlias}/foo";
        {
            match: and(isAbsoluteModule, isAliasModule),
            sort: moduleName(naturally),
            sortNamedMembers: alias(unicode)
        },
        { separator: true },
        // import … from "./foo";
        // import … from "../foo";
        {
            match: isRelativeModule,
            sort: [dotSegmentCount, moduleName(naturally)],
            sortNamedMembers: alias(unicode)
        },
        { separator: true },
    ];
});
